<script setup>
  import { cryptoPrice } from '@/services/cryptoPrices'
  import DropdownCrypto from '@/components/app/DropdownCrypto.vue'
  import { ref, reactive, computed, onMounted } from 'vue'

  const currencies = ref(['eur', 'usd', 'btc', 'eth'])
  const prices = ref({})
  const currentPrices = reactive({ from: 0, to: 0, rate: 0, usd: 0 })

  const dropdown = reactive({ from: '', to: '' })
  const showDropdown = reactive({ from: false, to: false })

  const nominalPrice = computed(() => Number(currentPrices.from * prices.value.conversion_rate_usd))
  const roundedNominalPrice = computed(() => nominalPrice.value.toFixed(2))
  const localStringNominalPrice = computed(() => Number(roundedNominalPrice.value).toLocaleString())

  const percentageFromTotal = computed(() => nominalPrice.value / 100 + nominalPrice.value)
  const roundedPercentageFromTotal = computed(() => Number(percentageFromTotal.value).toFixed(2))
  const localStringTotalPrice = computed(() => Number(roundedPercentageFromTotal.value).toLocaleString())

  // Close dropdown when clicking outside and select default currencies
  onMounted(async () => {
    document.addEventListener('click', () => {
      showDropdown.from = showDropdown.to = false
    })
    await getCurrentPrices('btc', 'usd')
    dropdown.from = 'btc'
    dropdown.to = 'usd'
    calculateAfterCurrencyChange()
  })

  const openDropdownList = (type) => {
    for (let key of Object.keys(showDropdown)) {
      if (type != key) {
        showDropdown[key] = false
      }
    }

    showDropdown[type] ? (showDropdown[type] = false) : (showDropdown[type] = true)
  }

  const chooseCurrency = (event, type) => {
    for (let [key, value] of Object.entries(dropdown)) {
      if (type != key && event == value) {
        dropdown[key] = dropdown[type]
      }
    }
    dropdown[type] = event
    getCurrentPrices(dropdown.from, dropdown.to)
  }

  const getCurrentPrices = async (from, to) => {
    try {
      const response = await cryptoPrice({ from: from, to: to })
      prices.value = response
      calculateAfterCurrencyChange()
    } catch (err) {
      console.log(err)
    }
  }

  const calculateAfterCurrencyChange = () => {
    currentPrices.usd = prices.value.conversion_rate_usd
    currentPrices.from = 1
    currentPrices.to = prices.value.conversion_rate
  }

  // calculating when value is changed
  const calculate = (type, value) => {
    if (type == 'from') {
      currentPrices.from = value
      currentPrices.to = currentPrices.from * prices.value.conversion_rate
    } else {
      currentPrices.to = value
      currentPrices.from = currentPrices.to / prices.value.conversion_rate
    }
  }
</script>

<template>
  <div class="bg-blue-200 h-screen flex items-center justify-center">
    <div class="bg-white w-1/3 h-auto p-10 border-t-2 border-blue-500">
      <div class="flex flex-col mb-8">
        <div class="flex justify-between items-center">
          <h1>Amount i have</h1>
          <span class="text-gray-400 text-xs">{{ localStringNominalPrice }} USD</span>
        </div>
        <div class="flex justify-between gap-2">
          <div class="border-b-2 w-full">
            <DropdownCrypto
              :currencies="currencies"
              @selectCurrency="chooseCurrency"
              @openDropdownList="openDropdownList('from')"
              :activeCurrency="dropdown.from"
              :active="showDropdown.from"
              dropdownType="from"
            />
          </div>
          <input
            type="number"
            @input="calculate('from', $event.target.value)"
            :value="currentPrices.from"
            class="max-w-[100px] h-[30px] text-center bg-gray-100 border rounded"
          />
        </div>
      </div>
      <div class="flex flex-col mb-8">
        <div class="flex justify-between items-center">
          <h1>I need</h1>
        </div>
        <div class="flex justify-between gap-2">
          <div class="border-b-2 w-full">
            <DropdownCrypto
              :currencies="currencies"
              @selectCurrency="chooseCurrency"
              :active="showDropdown.to"
              :activeCurrency="dropdown.to"
              @openDropdownList="openDropdownList('to')"
              dropdownType="to"
            />
          </div>
          <input
            type="number"
            @input="calculate('to', $event.target.value)"
            :value="currentPrices.to"
            class="max-w-[100px] h-[30px] text-center bg-gray-100 border rounded"
          />
        </div>
      </div>
      <div class="flex justify-between items-center bg-gradient-to-b from-blue-300 to-blue-100 p-2 rounded">
        <h1>Rate:</h1>
        <div class="text-blue-500 font-bold">$ {{ localStringTotalPrice }}</div>
      </div>
    </div>
  </div>
</template>
